--------------------------------------------------------------
--------------------------------------------------------------
--
--  std.vhd
--
--    This file contains VHDL descriptions for the basic
--  components identified by the base_cmos GES system.
--  Descriptions for the transistors are also included.
--  The body of most of the code must be filled in by the
--  user.

entity INV is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
          port (signal A:in bit;
                signal B:out bit);
end;
architecture inv of inv is
  begin
  --your code goes here.
  B <= not A; -- or use this.
  end inv;

entity INVZ is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
          port (signal P:in bit;
                signal N:in bit;
                signal A:in bit;
                signal B:out bit);
end;
architecture invZ of invZ is
  begin
  --your code goes here.
  end invZ;


entity NAND_GATE is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
         port  (signal A:in bit;
                signal B:in bit;
                signal C:out bit);
end;
architecture nand_gate of nand_gate is
  begin
  --your code goes here.
  C <= A nand B; -- or use this.
  end nand_gate;


entity NAND3_GATE is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
         port  (signal A:in bit;
                signal B:in bit;
                signal C:in bit; 
                signal D:out bit);
end;
architecture nand3_gate of nand3_gate is
  begin   
  --your code goes here.
  D <= not( A and B and C ); -- or use this.
  end nand3_gate;


entity XOR_GATE is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
         port  (signal A:in bit;
                signal B:in bit;
                signal C:out bit);
end;
architecture xor_gate of xor_gate is
  begin
  --your code goes here.
  C <= A xor B; -- or use this.
  end xor_gate;


entity XOR_GATE2 is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
         port  (signal A:in bit;
                signal Anot:out bit;
                signal B:in bit;
                signal Bnot:out bit;
                signal C:out bit);
end;
architecture xor_gate2 of xor_gate2 is
  begin
  --your code goes here.
  C <= A xor B; -- or use this.
  Anot <= not A;
  Bnot <= not B;
  end xor_gate2;


entity NOR_GATE is
    generic(constant tPLH:TIME:=0 ns;
            constant tPHL:TIME:=0 ns);
         port  (signal A:in bit;
                signal B:in bit;
                signal C:out bit);
end;
architecture nor_gate of nor_gate is
  begin
  --your code goes here.
  C <= A nor B; -- or use this.
  end nor_gate;


entity ptrans is
                generic (constant gate_length: integer := 0;
                    constant gate_width: integer := 0);
                  port ( Gate   : in bit;
                         Drain  : inout bit;
                         Source : inout bit);
                end ptrans;
architecture ptrans of ptrans is
  begin
  --your code goes here.
  end ptrans;


entity ntrans is
                generic (constant gate_length: integer := 0;
                    constant gate_width: integer := 0);
                  port ( Gate   : in bit;
                         Drain  : inout bit;
                         Source : inout bit);
                end ntrans;
architecture ntrans of ntrans is
  begin
  --your code goes here.
  end ntrans;


entity tgate is
                generic ( constant tPLH: TIME := 0 ns;
                    constant tPHL: TIME := 0 ns);
                port ( p1 : in bit;
                       p2 : in bit;
                       g  : inout bit;
                       d  : inout bit);
                end tgate;
architecture tgate of tgate is
  begin
  --your code goes here.
  end tgate;
